

%macro create_pay;
proc sql;
create table iss as select distinct
a.*, b.* from rsch.msf a , rsch.xfa b
where a.vid=b.vid and a.date=b.rdate
order by vid, rdate;

 
data iss;
set iss;
by vid rdate;
if first.vid then id = 0 ;
id + 1  ;
long = 0 ;

if abs(intck('month', lag(rdate), rdate)) ge 24 then long = 1;

shrout = shares * adj ;

lag_shrout = lag(shrout);

if lag_shrout ne . and shrout ne . then issue = shrout/lag(shrout)-1 ;

payout = NetIncome - (be-lag(be)) ;
profits = sales - cogs ;

PAY = (payout + lag(payout) + lag2(payout) + lag3(payout) + lag4(payout))/
(profits + lag(profits) + lag3(profits) + lag4(profits) + lag5(profits));


if id le 1 then ISSUE = . ;
if long = 1 then ISSUE = . ;

if id le 5 then PAY = . ;

run;


%add_date(iss);

proc sql;
create table ind.pay as select distinct a.*, b.PAY, b.ISSUE from rsch.acc a , iss b  where a.rdate=b.date and a.vid=b.vid;

%mend; 
