

%macro windsor(dataset = , var= , byvar = ,p1 = 1 , p2 = 99 , trim = 0); 

proc sort data = &dataset; by &byvar ; run ;
 
proc univariate data=  &dataset noprint;
  var &var; 
  by &byvar ; 
  output out = ppp pctlpts = &p1 &p2 pctlpre= P ;run; 

data &dataset; merge &dataset ppp ; 
by &byvar ; 

%if &trim = 1 %then %do ; 
if missing(&var) = 0 and &var<=  P&p1  then delete ; 
if missing(&var) = 0 and &var>=  P&p2  then delete ; 
%end ; 

%if &trim = 0 %then %do ; 
if missing(&var) = 0 and &var<=  P&p1  then &var = P&p1 ; 
if missing(&var) = 0 and &var>=  P&p2  then &var = P&p2 ; 
%end ; 

drop P&p1 P&p2  ; 
proc delete data = ppp ; run ; 

%mend ; 
