
clear all

if regexm(`"`c(pwd)'"',`"Elazarus"') {
	cd "/Users/Elazarus/Dropbox (Personal)/Work/Research/Niels/DurationBasedAP/Data and programs/Stata/Data/LTG"
}
else {
	cd "~/Dropbox/DurationBasedAP/Final Version/Data and programs/Input/Stata/Data/LTG"
}







clear all

use dividends_realized, clear
destring name, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm


egen id = concat(name ind), punct(-)

generate growth3 = div2/div1

reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) noabsorb
reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
outreg2 using ../../Tables/Table1A.doc,  replace ctitle(DividendGrowth)  label auto(2) excel tex(fragment) nocons   tstat noaster




clear all

use earnings_realized, clear
destring name, generate(id) ignore("USA" "W" "C" "__" )
gen y_m = ym(year(refresh_date),month(refresh_date))
format y_m %tm


egen id = concat(name ind), punct(-)
egen idn = group(id)
gen yr = year(refresh_date)
format yr %ty
tsset idn yr

generate growth3 = div2/div1

reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) noabsorb
reghdfe growth3 bm op low_inv low_beta pay  if year(refresh_date) >= 1963, cluster(id y_m) absorb(y_m)
outreg2 using ../../Tables/Table1A.doc,  append ctitle(EarningsGrowth)  label auto(2) excel tex(fragment) nocons tstat noaster










